
; Cria escada Caracol


(defun *error* (msg)
  (setvar "osmode"    osmatual)
  (setvar "orthomode" orthoatual)
  (command "zoom" "E" "")
;  (setq CodErro (getvar "errno"))
; (princ " -> Erro N.o ") (princ CodErro) (princ " = ") (princ msg)  
;  (ALERT "Entre <ARQ> para retornar ao menu.")
  (princ "\n*** Entre [CARACOL] para reiniciar.")   (princ)

) ; defun *error*


(defun c:CARACOL (/ path h sentido degrau coluna pb ndegraus espelho angdif ang)
  (setq osmatual   (getvar "osmode"))
  (setq orthoatual (getvar "orthomode"))
  (setvar "osmode" 0)
  (setvar "orthomode" 0)
  (setvar "dispsilh" 1)
  (setvar "cmdecho" 0)
;  (setq path "C:/Arquivos/AutoCAD/AutoLISP/CADesign/") ; Diretorio onde esta o lisp Caracol.lsp
  (setq Degrau "Degrau")
  (setq Coluna "Coluna")
  (setq h (getdist "\nDistancia entre o piso inf. e o piso superior (m):"))
  (if h
    (progn (initget "H A")
      (setq sentido (getkword "\nSentido H ou A:"))
      )
    )        
  (cond
    (
     (and sentido (setq pb (getpoint "\nClique no centro da escada:")))
     (command "insert" Coluna pb "XYZ" 1 1 h 0.0)
     (setq sentido (if (= sentido "H") -1 1))
     (setq espelho 0.175)                       ; valor max
;     (setq ndegraus (fix+1 (/ h espelho)))
     (setq ndegraus (+ 1 (fix (/ h espelho))))
     (setq espelho (/ h ndegraus))              ; valor recalculado
     (setq angdif 30.0)
     (if (= sentido -1)
       (setq ang (- angdif))
       (setq ang 0.0)
       )
     (repeat ndegraus
       (setq pb (mapcar '+ pb (list 0 0 espelho)))
;       (command "insert" (strcat path degrau) pb 1 1 ang)
        (command "insert" degrau pb 1 1 ang)
       (setq ang (+ ang (* sentido angdif)))
       )
     )
    )
  (princ)
 
  (setvar "osmode"  osmatual)
  (setvar "orthomode" orthoatual)
 
  (command "zoom" "e" "")

  (setq Opcao (getstring "\nDeseja visao 3D da ESCADA CARACOL (S/N): "))
  (if (or (= Opcao "S") (= Opcao "s")) (Visao3D) (Exit))
  
  ) ; Fdefun c:Caracol

(defun Visao3D ()


  (command "vpoint" "R" "225" "30" "")
  (command "hide" "")
  (getstring "\nDigite Enter para sombrear: ")
  (command "shade" "")
  (command "ddview")
 (setq Opcao (getstring "\nTecle ENTER para visao 2D: "))
  (command "plan" "" "")
;  (princ "\n*** Entre [CARACOL] para reiniciar.")
   (EXIT)
) ; FdefunVisao3D


(alert "\n       'ESCADA CARACOL' \n
\n         Lisp para AutoCAD\n          Roberto Magnani
\n  http://robertomagnani.tripod.com.br \n roberto.magnani@bol.com.br \n             Setembro/2004")


(princ "roberto.magnani@bol.com.br *** Entre [CARACOL] para iniciar:")


